import { ArrayOps } from './array_ops';
import { BatchNormOps } from './batchnorm';
import { BinaryOps } from './binary_ops';
import { CompareOps } from './compare';
import { ConcatOps } from './concat';
import { ConvOps } from './conv';
import { ImageOps } from './image_ops';
import { LogicalOps } from './logical_ops';
import { LossOps } from './loss_ops';
import { LRNOps } from './lrn';
import { LSTMOps } from './lstm';
import { MatmulOps } from './matmul';
import { MovingAverageOps } from './moving_average';
import { NormOps } from './norm';
import { PoolOps } from './pool';
import { ReductionOps } from './reduction_ops';
import { ReverseOps } from './reverse';
import { SliceOps } from './slice';
import { SoftmaxOps } from './softmax';
import { TransposeOps } from './transpose';
import { UnaryOps } from './unary_ops';
export declare const batchNormalization: typeof BatchNormOps.batchNormalization;
export declare const batchNormalization2d: typeof BatchNormOps.batchNormalization2d;
export declare const batchNormalization3d: typeof BatchNormOps.batchNormalization3d;
export declare const batchNormalization4d: typeof BatchNormOps.batchNormalization4d;
export declare const concat: typeof ConcatOps.concat;
export declare const concat1d: typeof ConcatOps.concat1d;
export declare const concat2d: typeof ConcatOps.concat2d;
export declare const concat3d: typeof ConcatOps.concat3d;
export declare const concat4d: typeof ConcatOps.concat4d;
export declare const conv1d: typeof ConvOps.conv1d;
export declare const conv2d: typeof ConvOps.conv2d;
export declare const conv2dTranspose: typeof ConvOps.conv2dTranspose;
export declare const depthwiseConv2d: typeof ConvOps.depthwiseConv2d;
export declare const separableConv2d: typeof ConvOps.separableConv2d;
export declare const matMul: typeof MatmulOps.matMul;
export declare const matrixTimesVector: typeof MatmulOps.matrixTimesVector;
export declare const outerProduct: typeof MatmulOps.outerProduct;
export declare const vectorTimesMatrix: typeof MatmulOps.vectorTimesMatrix;
export declare const avgPool: typeof PoolOps.avgPool;
export declare const maxPool: typeof PoolOps.maxPool;
export declare const transpose: typeof TransposeOps.transpose;
export declare const reverse: typeof ReverseOps.reverse;
export declare const reverse1d: typeof ReverseOps.reverse1d;
export declare const reverse2d: typeof ReverseOps.reverse2d;
export declare const reverse3d: typeof ReverseOps.reverse3d;
export declare const reverse4d: typeof ReverseOps.reverse4d;
export declare const slice: typeof SliceOps.slice;
export declare const slice1d: typeof SliceOps.slice1d;
export declare const slice2d: typeof SliceOps.slice2d;
export declare const slice3d: typeof SliceOps.slice3d;
export declare const slice4d: typeof SliceOps.slice4d;
export declare const argMax: typeof ReductionOps.argMax;
export declare const argMin: typeof ReductionOps.argMin;
export declare const logSumExp: typeof ReductionOps.logSumExp;
export declare const max: typeof ReductionOps.max;
export declare const mean: typeof ReductionOps.mean;
export declare const min: typeof ReductionOps.min;
export declare const moments: typeof ReductionOps.moments;
export declare const sum: typeof ReductionOps.sum;
export declare const equal: typeof CompareOps.equal;
export declare const equalStrict: typeof CompareOps.equalStrict;
export declare const greater: typeof CompareOps.greater;
export declare const greaterStrict: typeof CompareOps.greaterStrict;
export declare const greaterEqual: typeof CompareOps.greaterEqual;
export declare const greaterEqualStrict: typeof CompareOps.greaterEqualStrict;
export declare const less: typeof CompareOps.less;
export declare const lessStrict: typeof CompareOps.lessStrict;
export declare const lessEqual: typeof CompareOps.lessEqual;
export declare const lessEqualStrict: typeof CompareOps.lessEqualStrict;
export declare const notEqual: typeof CompareOps.notEqual;
export declare const notEqualStrict: typeof CompareOps.notEqualStrict;
export declare const logicalNot: typeof LogicalOps.logicalNot;
export declare const logicalAnd: typeof LogicalOps.logicalAnd;
export declare const logicalOr: typeof LogicalOps.logicalOr;
export declare const logicalXor: typeof LogicalOps.logicalXor;
export declare const where: typeof LogicalOps.where;
export declare const abs: typeof UnaryOps.abs;
export declare const acos: typeof UnaryOps.acos;
export declare const acosh: typeof UnaryOps.acosh;
export declare const asin: typeof UnaryOps.asin;
export declare const asinh: typeof UnaryOps.asinh;
export declare const atan: typeof UnaryOps.atan;
export declare const atanh: typeof UnaryOps.atanh;
export declare const ceil: typeof UnaryOps.ceil;
export declare const clipByValue: typeof UnaryOps.clipByValue;
export declare const cos: typeof UnaryOps.cos;
export declare const cosh: typeof UnaryOps.cosh;
export declare const elu: typeof UnaryOps.elu;
export declare const exp: typeof UnaryOps.exp;
export declare const expm1: typeof UnaryOps.expm1;
export declare const floor: typeof UnaryOps.floor;
export declare const sign: typeof UnaryOps.sign;
export declare const leakyRelu: typeof UnaryOps.leakyRelu;
export declare const log: typeof UnaryOps.log;
export declare const log1p: typeof UnaryOps.log1p;
export declare const logSigmoid: typeof UnaryOps.logSigmoid;
export declare const neg: typeof UnaryOps.neg;
export declare const prelu: typeof UnaryOps.prelu;
export declare const relu: typeof UnaryOps.relu;
export declare const reciprocal: typeof UnaryOps.reciprocal;
export declare const round: typeof UnaryOps.round;
export declare const selu: typeof UnaryOps.selu;
export declare const sigmoid: typeof UnaryOps.sigmoid;
export declare const sin: typeof UnaryOps.sin;
export declare const sinh: typeof UnaryOps.sinh;
export declare const softplus: typeof UnaryOps.softplus;
export declare const sqrt: typeof UnaryOps.sqrt;
export declare const rsqrt: typeof UnaryOps.rsqrt;
export declare const square: typeof UnaryOps.square;
export declare const step: typeof UnaryOps.step;
export declare const tan: typeof UnaryOps.tan;
export declare const tanh: typeof UnaryOps.tanh;
export declare const erf: typeof UnaryOps.erf;
export declare const add: typeof BinaryOps.add;
export declare const addStrict: typeof BinaryOps.addStrict;
export declare const atan2: typeof BinaryOps.atan2;
export declare const div: typeof BinaryOps.div;
export declare const divStrict: typeof BinaryOps.divStrict;
export declare const maximum: typeof BinaryOps.maximum;
export declare const maximumStrict: typeof BinaryOps.maximumStrict;
export declare const minimum: typeof BinaryOps.minimum;
export declare const minimumStrict: typeof BinaryOps.minimumStrict;
export declare const mod: typeof BinaryOps.mod;
export declare const modStrict: typeof BinaryOps.modStrict;
export declare const mul: typeof BinaryOps.mul;
export declare const mulStrict: typeof BinaryOps.mulStrict;
export declare const pow: typeof BinaryOps.pow;
export declare const powStrict: typeof BinaryOps.powStrict;
export declare const sub: typeof BinaryOps.sub;
export declare const subStrict: typeof BinaryOps.subStrict;
export declare const squaredDifference: typeof BinaryOps.squaredDifference;
export declare const squaredDifferenceStrict: typeof BinaryOps.squaredDifferenceStrict;
export declare const norm: typeof NormOps.norm;
export declare const cast: typeof ArrayOps.cast;
export declare const clone: typeof ArrayOps.clone;
export declare const fromPixels: typeof ArrayOps.fromPixels;
export declare const toPixels: typeof ArrayOps.toPixels;
export declare const ones: typeof ArrayOps.ones;
export declare const onesLike: typeof ArrayOps.onesLike;
export declare const zeros: typeof ArrayOps.zeros;
export declare const zerosLike: typeof ArrayOps.zerosLike;
export declare const rand: typeof ArrayOps.rand;
export declare const randomNormal: typeof ArrayOps.randomNormal;
export declare const truncatedNormal: typeof ArrayOps.truncatedNormal;
export declare const randomUniform: typeof ArrayOps.randomUniform;
export declare const multinomial: typeof ArrayOps.multinomial;
export declare const reshape: typeof ArrayOps.reshape;
export declare const squeeze: typeof ArrayOps.squeeze;
export declare const tile: typeof ArrayOps.tile;
export declare const gather: typeof ArrayOps.gather;
export declare const oneHot: typeof ArrayOps.oneHot;
export declare const linspace: typeof ArrayOps.linspace;
export declare const range: typeof ArrayOps.range;
export declare const buffer: typeof ArrayOps.buffer;
export declare const fill: typeof ArrayOps.fill;
export declare const tensor: typeof ArrayOps.tensor;
export declare const scalar: typeof ArrayOps.scalar;
export declare const tensor1d: typeof ArrayOps.tensor1d;
export declare const tensor2d: typeof ArrayOps.tensor2d;
export declare const tensor3d: typeof ArrayOps.tensor3d;
export declare const tensor4d: typeof ArrayOps.tensor4d;
export declare const print: typeof ArrayOps.print;
export declare const expandDims: typeof ArrayOps.expandDims;
export declare const stack: typeof ArrayOps.stack;
export declare const split: typeof ArrayOps.split;
export declare const pad: typeof ArrayOps.pad;
export declare const pad1d: typeof ArrayOps.pad1d;
export declare const pad2d: typeof ArrayOps.pad2d;
export declare const pad3d: typeof ArrayOps.pad3d;
export declare const pad4d: typeof ArrayOps.pad4d;
export declare const movingAverage: typeof MovingAverageOps.movingAverage;
export declare const basicLSTMCell: typeof LSTMOps.basicLSTMCell;
export declare const multiRNNCell: typeof LSTMOps.multiRNNCell;
export declare const softmax: typeof SoftmaxOps.softmax;
export declare const localResponseNormalization: typeof LRNOps.localResponseNormalization;
export declare const losses: {
    softmaxCrossEntropy: typeof SoftmaxOps.softmaxCrossEntropy;
    absoluteDifference: typeof LossOps.absoluteDifference;
    computeWeightedLoss: typeof LossOps.computeWeightedLoss;
};
export declare const image: {
    resizeBilinear: typeof ImageOps.resizeBilinear;
    resizeNearestNeighbor: typeof ImageOps.resizeNearestNeighbor;
};
